<?php
namespace Controller;

use Service\Traits\TResponse;
use Util\Utilities;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;


class Language extends Crud {
    
    use TResponse;
    
	protected $dataSourceName = 'language';
	
	public function findNext(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        $filterData = new FilterCriteria($this->dataSourceName,array());
        if (array_key_exists("in", $params)) {
            $searchField = $params["in"];
            $filterData->addCondition($searchField, is_array($params[$searchField]) ? FilterCriteria::IN : FilterCriteria::EQ, $params[$searchField]);
        }
        $filterData->setDataSourceName($this->dataSourceName);
        $rows = $this->mongoManager->findBy($filterData)->getRows();
        $this->sendResponse(Utilities::parseDataSourceZeedhiNext($rows), 200);
    }
}