import {ChartViewInterface} from "@/Services/ChartView/ChartViewInterface";
import {ChartViewAbstract} from "@/Services/ChartView/ChartViewAbstract";
import {ZmartChartsApex} from "@/Services/Chats/ZmartChartsApex";
import {ChartViewService} from "@/Services/ChartViewService";

export class Area extends ChartViewAbstract implements ChartViewInterface {
    public getWidget(dashboard: any, widget: any) {
        const height = widget[0].style;
        if (dashboard.label !== '' || dashboard.label !== null) {
            widget[0].options.title.text = dashboard.label;
        }
        widget[0].style = "background: " + dashboard.color + "; " + height;
        return widget;
    }

    public getSaveViewParams(formExtra: any, values: any, cleanValues: any) {
        if (values.chartXAxisBandDimensionGap) {
            cleanValues.chartXAxisBandDimensionGap = parseFloat(cleanValues.chartXAxisBandDimensionGap);
        }
        cleanValues.chartSeries = [
            {
                serieColor: [null],
                serieColors: values.serieColors || null,
                serieFields: values.serieFields || null,
                serieLabels: values.serieLabels || null,
                serieLineWidth: values.serieLineWidth || null,
                serieStacked: values.serieStacked || null,
                serieLineType: values.serieLineType || null,
                serieYAxisFormat: values.serieYAxisFormat || null,
                serieType: values.serieType || null
            }

        ];
        cleanValues.serieColors = cleanValues.originSerieColors;
        return cleanValues;
    }

    public getEditData(viewData: any) {
        if (Array.isArray(viewData.serieColors)) {
            viewData.originSerieColors = viewData.serieColors;
            viewData.serieColors = viewData.serieColors[0];
        }
        return viewData;
    }

    public getCharts(charts: any) {
        return charts;
    }

    public setMask(charts: any) {
        if (charts[0].options.yAxis.axisLabel && charts[0].options.yAxis.maskFunction) {
            const maskFunction = ChartViewService.getMaskFunction(charts[0].options.yAxis.maskFunction);
            charts[0].options.yAxis.axisLabel.formatter = maskFunction;
            charts[0].options.tooltip.valueFormatter = maskFunction;
            charts[0].options.series.forEach((serie: any) => {
                if (serie.label) {
                    serie.label.formatter = this.setMaskSerie.bind(this, maskFunction);
                }
            });
            charts[0].options.tooltip.valueFormatter = maskFunction;
        }
    }

    public setMaskSerie(maskFunction: any, param: any) {
        return maskFunction(param.value);
    }

    public setDrill(charts: any, zmartCharts: ZmartChartsApex) {
        this.zmartCharts = zmartCharts;
        this.setMask(charts);

        charts[0].events = {
            "mounted": this.getZmartCharts().mounted.bind(this.getZmartCharts()),
            "chartClick": this.getZmartCharts().drillEChartsBar.bind(this.getZmartCharts(), charts[0].widget),
        };

        return charts;
    }

}
