import {ChartViewInterface} from "@/Services/ChartView/ChartViewInterface";
import {ChartViewAbstract} from "@/Services/ChartView/ChartViewAbstract";
import {ZmartChartsApex} from "@/Services/Chats/ZmartChartsApex";
import {ChartViewService} from "@/Services/ChartViewService";

export class Bar extends ChartViewAbstract implements ChartViewInterface {
    public getWidget(dashboard: any, widget: any):any {
        const height = widget[0].style;
        if (dashboard.label !== '' || dashboard.label !== null) {
            widget[0].options.title.text = dashboard.label;
        }
        widget[0].style = "background: " + dashboard.color + "; " + height;
        return widget;
    }

    public getCharts(charts: any) {
        return charts;
    }

    public setMaskSerie(maskFunction: any, param: any) {
        return maskFunction(param.value);
    }

    public setMask(charts: any) {
        if (charts[0].options.xAxis.axisLabel && charts[0].options.xAxis.maskFunction) {
            const maskFunction = ChartViewService.getMaskFunction(charts[0].options.xAxis.maskFunction);
            charts[0].options.xAxis.axisLabel.formatter = maskFunction;
            charts[0].options.tooltip.valueFormatter = maskFunction;
            charts[0].options.series.forEach((serie: any) => {
                if (serie.label) {
                    serie.label.formatter = this.setMaskSerie.bind(this, maskFunction);
                }
            });
            charts[0].options.tooltip.valueFormatter = maskFunction;
        }
    }

    public setDrill(charts: any, zmartCharts: ZmartChartsApex) {
        this.zmartCharts = zmartCharts;
        this.setMask(charts);

        charts[0].events = {
            "chartClick": this.getZmartCharts().drillEChartsBar.bind(this.getZmartCharts(), charts[0].widget),
        };

        return charts;
    }
}
